#!/usr/bin/perl
#!c:\perl\bin\perl.exe

# SMTP Honeypot
# (c) 2007 – admin at abuse.ch
# Version 1.2 - DATE: FEB 9th 2007
# mod by hermes - DATE: NOV 27th 2010

use Socket;
use strict;

# Port on which the service will be run
my $port = 25;

# The name of the hostname you want to simulate eg. mail.example.com
my $host = "YOURHOST.dyndns.com";

# SMTP-Daemon Version
my $smtpver = "Sendmail 8.14.0";

# Get the protocol nr. of TCP
my $tcp = getprotobyname('tcp');

# Path to Logfile
my $logfile = './honeypot.log';

# Path to Blacklist
my $blacklist = './honeyblacklist.txt';

# Define variables
my $lastline;
my $ipaddress;

# Create a socket at $port with protocol $tcp
socket(Server, PF_INET, SOCK_STREAM, $tcp) or die "socket: $!";
setsockopt(Server, SOL_SOCKET, SO_REUSEADDR, pack("l", 1)) or die "setsockopt: $!";
bind(Server, sockaddr_in($port, INADDR_ANY)) or die "bind: $!";
listen(Server,SOMAXCONN) or die "listen: $!";
print STDERR ("\n");

# Display a message that the server is now running
logmsg ("SMTP server started on port ", $port, "\n\n");

my ( $addr, @inetaddr );

my $old_handle = select Client;

$| =1;

select $old_handle;

*STDOUT = *Client;
*STDIN = *Client;

while (1)
{

	$addr = accept(Client,Server);

	my(undef, undef, $inetaddr) = unpack('S n a4 x8', $addr);
	@inetaddr = unpack('C4', $inetaddr);

	print STDERR ("\n\n");

	logmsg ("SRV: incoming connection from: ", join(".", @inetaddr));

=for comment
# Save to blacklist.txt START
	open (DATA, "+>>$blacklist") or die "can't open $blacklist $!";
	print DATA join(".", @inetaddr), "\n";
	close (DATA);
# Save to blacklist.txt END

# Save to blacklist.txt START
	my $ipaddr = join(".", @inetaddr);
	my $host = gethostbyaddr($ipaddr, AF_INET);
	open (DATA, "+>>$blacklist") or die "can't open $blacklist $!";
	print DATA "$host \n";
	close (DATA);
# Save to blacklist.txt END
=cut

	&READ();
}

close Client;

sub logmsg
{
	print STDERR "\n", (scalar (localtime), ": ", $$, ": ", @_);
	# Save to Logfile START
	open (DATA, "+>>$logfile") or die "can't open $logfile $!";
	print DATA "\n", (scalar (localtime), ": ", $$, ": ", @_);
	close (DATA);
	# Save to Logfile END
}

sub READ
{

	my $saidhelo = 0;
	my $saidmail = 0;
	my $maildata;

	print ("220 ", $host, ' ', $smtpver, ' ', scalar (localtime), "\r\n");
	logmsg("SRV: 220 ", join($host, ' ', $smtpver));

	while (1)
	{
		my $commands = <STDIN>;

		if (!defined ($commands))
		{
			return;
		}

		$commands =~ s/[\r\n]+|\s+$//g;
		my @commands = split (/\s+/, $commands);

		logmsg ("CLN: ", $commands, "\n");

		if (!defined $commands[1])
		{
			$commands[1] = '';
		}

		if (!defined $commands[2])
		{
			$commands[2] = '';
		}

		my %smtphash = (
			AUTH => "503 AUTH mechanism not available.\x0d\x0a",
			BADRCPT => "503 5.0.0 Need MAIL before RCPT\x0d\x0a",
			BADHELO => "503 5.0.0 Polite people say HELO first\x0d\x0a",
			DATA => "354 Enter mail, end with \"\.\" on a line by itself\x0d\x0a",
			DATAerr => "503 5.0.0 Need MAIL command\x0d\x0a",
			DATAsent => "250 2.0.0 g8684xUD014698 Message accepted for delivery\x0d\x0a",
			EHLOOUT => "501 5.0.0 HELO requires domain address.\x0d\x0a",
			ERR => "500 5.5.1 Command unrecognized: $commands\x0d\x0a",
			ETRN => "500 5.5.2 Parameter required\x0d\x0a",
			EXPN => "502 5.7.0 Sorry, we do not allow this operation.\x0d\x0a",
			HELOERR => "501 5.0.0 Invalid domain name\x0d\x0a",
			HELOOUT => "501 5.0.0 HELO requires domain address.\x0d\x0a",
			HELOIN => "250 $host Hello $commands[1], pleased to meet you.\x0d\x0a",
			MAILFROM => "553 5.5.4 MAILDATA... Domain name required for sender address MAILDATA\x0d\x0a",
			MAILTO => "250 2.1.0 MAILDATA... Sender ok\x0d\x0a",
			MAIL => "501 5.5.2 Syntax error in parameters scanning \"$commands[1]\"\x0d\x0a",
			NOOP => "250 2.0.0 OK.\x0d\x0a",
			QUIT => "221 2.0.0 $host closing connection..\x0d\x0a",
			RCPTTO => "250 2.1.5 MAILDATA... Recipient ok\x0d\x0a",
			RESET => "250 2.0.0 Reset state.\x0d\x0a",
			RSET => "250 2.0.0 Reset state\x0d\x0a",
			STARTTLS => "454 4.3.3 TLS not available after start...\x0d\x0a",
			VRFY => "252 2.5.2 Cannot VRFY user; try RCPT to attempt delivery (or try finger).\x0d\x0a",
			HELP => "214-2.0.0 Sendmail v8.4.3\x0d\x0a214-2.0.0 Topics:\x0d\x0a214-2.0.0 HELO EHLO MAIL RCPT DATA\x0d\x0a214-2.0.0 RSET NOOP QUIT HELP VRFY\x0d\x0a214-2.0.0 EXPN VERB ETRN DSN AUTH\x0d\x0a214-2.0.0 STARTTLS\x0d\x0a214-2.0.0 For more info use \"HELP \".\x0d\x0a214-2.0.0 For local information send email to Postmaster at your site.\x0d\x0a214 2.0.0 End of HELP info.\x0d\x0a",
			EHLO => "250-ENHANCEDSTATUSCODES\x0d\x0a250-8BITMIME\x0d\x0a250-SIZE\x0d\x0a250-DSN\x0d\x0a250-ONEX\x0d\x0a250-ETRN\x0d\x0a250-XUSR\x0d\x0a250 HELP\x0d\x0a",

		);

		if (!defined ($commands[0]) or $commands[0] eq '')
		{
			next;
		}
		elsif ($commands[0] =~ /^HELO$/i)
		{
			if($commands[1] eq '')
			{
				print ($smtphash{HELOOUT});
				logmsg("SRV: ", $smtphash{HELOOUT});
			}
			elsif ($commands[1] =~ /[\!\@\#\$\%\^&\*\(\)\|\\,>?\/\"\':;\{\}]/)
			{
				print $smtphash{HELOERR};
				logmsg("SRV: ", $smtphash{HELOERR});
			}
			else
			{
				print $smtphash{HELOIN};
				logmsg("SRV: ", $smtphash{HELOIN});
				$saidhelo = 1;
			}
		}
#		elsif ($commands[0] =~ /^HELP$|^RESET$|^NOOP$|^AUTH$|^STARTTLS$|^VRFY$|^EXPN$|^ETRN$|^RSET$/i)
		elsif ($commands[0] =~ /^HELP$|^RESET$|^NOOP$|^AUTH$|^STARTTLS$|^VRFY$|^EXPN$|^ETRN$|^RSET$/)
		{
			# Kinda dummy commands
			print ($smtphash{$commands[0]});
			logmsg("SRV: ", $smtphash{$commands[0]});
			sleep 1;
		}
		elsif ($commands[0] =~ /^EHLO$/i)
		{
			if($commands[1] eq '')
			{
				#print ($smtphash{EHLOOUT});
				logmsg("SRV: ", $smtphash{EHLOOUT});
			}
			else
			{
				print ($smtphash{HELOIN});
				logmsg("SRV: ", $smtphash{HELOIN});
				#print ($smtphash{EHLO});
				logmsg("SRV: ", $smtphash{EHLO});
				$saidhelo = 1;
			}
		}
		elsif ($commands[0] =~ /^QUIT$/i)
		{
			print $smtphash{QUIT};
			logmsg("SRV: ", $smtphash{QUIT});
			return;
		}
		elsif ($commands[0] =~ /^MAIL$/i)
		{
			$maildata = $commands[2];
			if ($commands[2] eq '')
			{
				$maildata = $commands[1];
				if ($commands[1] =~ m@.*from:<(.*)>@i)
				{
					$maildata = $1;
				}
			}

			if ($saidhelo == 0)
			{
				print $smtphash{BADHELO};
				logmsg("SRV: ", $smtphash{BADHELO});
				
				# Is there a space after from:
			}
			elsif ($commands[1] =~ /from:/i)
			{
				if ($commands[2] =~ /\@/ || $commands[1] =~ /\@/)
				{
					$saidmail = 1;
					$smtphash{MAILTO} =~ s/MAILDATA/$maildata/g;
					print ($smtphash{MAILTO});
					logmsg("SRV: ", $smtphash{MAILTO});
				}
				else
				{
					$smtphash{MAILFROM} =~ s/MAILDATA/$maildata/g;
					print ($smtphash{MAILFROM});
					logmsg("SRV: ", $smtphash{MAILFROM});
				}
			}
			elsif ($saidhelo == 1)
			{
				#print ("250 2.1.5 $maildata... Recipient ok\x0d\x0a");
				print ($smtphash{MAIL});
				logmsg("SRV: ", $smtphash{MAIL});
			}
		}
		elsif ($commands[0] =~ /^RCPT$/i)
		{
			$maildata = $commands[2];
			#if ($commands[1] =~ m@.*to:<(.*)>@i || $commands[2] =~ m@<(.*)>@ )
			if ($commands[1] =~ /to:<(.*?)>/i || $commands[2] =~ /<(.*?)>/ )
			{
				$maildata = $1;
			}
			elsif ($commands[1] =~ /to: <(.*?)>/i || $commands[1] =~ /<(.*?)>/ )
			{
				$maildata = $2;
			}
			else
			{
				print ($smtphash{MAIL});
				logmsg("SRV: ", $smtphash{MAIL});
			}

			$smtphash{RCPTTO} =~ s/MAILDATA/$maildata/g;
			print($smtphash{RCPTTO});
			logmsg("SRV: ", $smtphash{RCPTTO});
=for comment
			if ($commands[1] =~ /to:<(.*?)>/i || $commands[2] =~ /<(.*?)>/ )
			{
				$maildata = $1;
			}
			if ($saidmail == 0)
			{
				print ($smtphash{BADRCPT});
				logmsg("SRV: ", $smtphash{BADRCPT});
			}
			else
			{
				# Is there a space after to:
				if ($commands[1] =~ /to:/ && $maildata ne '')
				{
					print ("250 2.1.5 $maildata... Recipient ok\x0d\x0a");
					logmsg("SRV: ", "250 2.1.5 $maildata... Recipient ok\x0d\x0a");
				}
				else
				{
					#print ("250 2.1.5 $maildata... Recipient ok\x0d\x0a");
					print ($smtphash{MAIL});
					logmsg("SRV: ", $smtphash{MAIL});
				}
			}
=cut
		}
		elsif ($commands[0] =~ /^DATA$/i)
		{
				if ($saidmail == 1)
				{
					print ($smtphash{DATA});
					logmsg("SRV: ", $smtphash{DATA});
					
					my $z = 0;
					while (defined(my $lastline = <STDIN>))
					{
						print STDERR ($lastline);
						last if $lastline =~ /^\.\x0d\x0a$/;
					}
					print ($smtphash{DATAsent});
					logmsg("SRV: ", $smtphash{DATAsent});
				}
				else
				{
					print ($smtphash{DATAerr});
					logmsg("SRV: ", $smtphash{DATAerr});
				}

		}
		else
		{
			print ($smtphash{ERR});
			logmsg("SRV: ", $smtphash{ERR}, ": ERROR cmd1: " , $commands[1], " cmd2: " , $commands[2]);
		}
	}
}
